--wMerchant.PlayerSales = {}

-- if not wMerchant.PlayerSales then wMerchant.PlayerSales = {} end


-- local PS = wMerchant.PlayerSales
local WM = wMerchant -- Get shortcut to wMerchant object (table)


function WM:InitPlayerSales()
	
	wMerchantDisplayPlayerSales:SetState(BSTATE_NORMAL, false)
	
	--self.Parent.UI:InitPlayerSales()
	self:RenderPlayerSales()
end

function WM:HidePlayerSalesFrame()
	wMerchantDisplayPlayerSalesFrame:SetHidden(true)
end

function WM.ShowPlayerSalesFrame()
	wMerchantDisplayPlayerSalesFrame:SetHidden(false)
end

function WM:RenderPlayerSales()

	-- local ss
	local wm = WINDOW_MANAGER


	-- ss = wMerchantDisplayPlayerSalesFrame

	container = WZ.Chain(WINDOW_MANAGER:CreateControlFromVirtual("name", wMerchantDisplayPlayerSalesFrame, "ZO_ScrollContainer"))
		:SetAnchor(TOPLEFT, ss, TOPLEFT, 2, 2)
		:SetAnchor(BOTTOMRIGHT, ss, BOTTOMRIGHT, 2, 2)
		--:SetDimensions(900,300)
	.__END

	--set some anchors, create backdrop etc.

	-- ss.bg = WZ.Chain( wm:CreateControl("ss.bg", container, CT_BACKDROP))
	-- 	:SetAnchor(TOPLEFT, ss, TOPLEFT, 2, 2)
	-- 	:SetAnchor(BOTTOMRIGHT, ss, BOTTOMRIGHT, 2, 2)
	-- 	:SetEdgeColor(.3,.3,.3,.5)
 --  		:SetCenterColor(.1,.1,.1,.99)
 --  		:SetAnchor(TOPLEFT, container, TOPLEFT, 0, 0)
	--   	-- :SetDimensions(900,300)
	--   	:SetDrawLayer(10)
 --  	.__END

	 
	scroll = container:GetNamedChild("ScrollChild")

	self.Container = {
		ItemBox = scroll,
		ScrollContainer = container,
		Window = ss
	}

	self.BaseFont = "$(MEDIUM_FONT)|16|soft-shadow-thin"


	--self:RenderOneItem(1, nil)
	


-- ss.row1:GetNamedChild("SellTime"):SetText("abc")

-- ss.row1:GetNamedChild("SellTime"):SetFont(font)
-- ss.row1:GetNamedChild("SellTime"):SetColor(0.8, 0.8, 0.8, 1)
-- ss.row1:GetNamedChild("SellTime"):SetScale(1)


-- local z = ss.row1:GetNamedChild("Price")
-- local x = WINDOW_MANAGER:GetControlByName("oneitemItemName")
-- --local x2 = WINDOW_MANAGER:GetControlByName("oneitemPrice")
-- z:SetText("hejsan")
-- z:SetHidden(false)
-- --x2:SetText("hejsan")
-- d("tjosan")
-- d(z)




	  	-- ss.row1 = WZ.Chain( wm:CreateControl("ss.row1", scroll, CT_LABEL) )
	  	-- 	:SetText("Some info")
	  	-- 	:SetFont("ZoFontAlert")
	  	-- 	:SetColor(0.8, 0.8, 0.8, 1)
	  	-- 	:SetScale(1)
	  	-- 	:SetAnchor(TOPLEFT, scroll, TOPLEFT, 0, 0)

	  	-- 	:SetDrawLayer(5)
	  	-- .__END

	local numItems = tablelength(WMDB.PlayerSales)



	--for i=1,numItems do
	local index = 0
	for k,v in WZ.Spairs(WMDB.PlayerSales, WM.SortByTimestampDesc) do
		index = index + 1
		  	-- ss.row2 = WZ.Chain( wm:CreateControl("ss.row" .. i + 1, scroll, CT_LABEL) )
		  	-- 	:SetText("Some info " .. i + 1)
		  	-- 	:SetFont("ZoFontAlert")
		  	-- 	:SetColor(0.8, 0.8, 0.8, 1)
		  	-- 	:SetScale(1)
		  	-- 	:SetAnchor(TOPLEFT, scroll, TOPLEFT, 0, ((i - 1) * 20))
		  	-- 	:SetDrawLayer(5)
		  	-- .__END
		self:RenderOneItem(index, v)
	end--for

end--function

function WM.SortByTimestamp(t,a,b)
	local FIELDS = WMDB.SCHEMA.PLAYERSALES_FIELDS
	return t[b][FIELDS.TimeStamp] > t[a][FIELDS.TimeStamp]
end

function WM.SortByTimestampDesc(t,a,b)
	local FIELDS = WMDB.SCHEMA.PLAYERSALES_FIELDS
	return t[b][FIELDS.TimeStamp] < t[a][FIELDS.TimeStamp]
end

function WM:RenderOneItem(index, salesItem)

	local FIELDS = WMDB.SCHEMA.PLAYERSALES_FIELDS

	local anchorParent
	local anchorPoint
	local rowAlpha
	local rowColor


	index = tonumber(index)

	if index == 1 then
		anchorPoint = TOPLEFT
		anchorParent = self.Container.ItemBox
	else
		anchorPoint = BOTTOMLEFT
	    anchorParent = WINDOW_MANAGER:GetControlByName("wMerchantDataRow" .. index - 1)
	end

	if index % 2 == 0 then
		rowAlpha = 0.1 -- even row
		rowColor = 255, 255, 255, 0.2
	else
		rowAlpha = 0.2 -- odd row
		rowColor = 200, 200, 200, 0.3
	end--if

	local row = WZ.Chain(WINDOW_MANAGER:CreateControlFromVirtual("wMerchantDataRow" .. index, self.Container.ItemBox, "wMerchantDataRow"))
		:SetAnchor(TOPLEFT, anchorParent, index == 1 and TOPLEFT or BOTTOMLEFT, 0, 0)
		--:SetAnchor(TOPRIGHT, anchorParent, index == 1 and TOPRIGHT or BOTTOMRIGHT, 0, 0)
		:SetDimensions(self.Container.ScrollContainer:GetWidth(), 25)
  		:SetDrawLayer(5)
	.__END

if index % 2 == 0 then
	local row_bg = WZ.Chain(row:GetNamedChild("Background"))
		:SetCenterColor(200, 200, 200)
		:SetAlpha(0.12)
	.__END
else
	local row_bg = WZ.Chain(row:GetNamedChild("Background"))
		:SetCenterColor(200, 200, 200)
		:SetAlpha(0.08)
	.__END

end

	-- local row_bg = WZ.Chain(row:GetNamedChild("Background"))
	-- 	:SetCenterColor(rowColor)
	-- .__END



	--self.GetItemLink(10061, 42, 50, 0)
	--local itemID, level, quality, enchantmentID = self.ParseItemUID(salesItem[FIELDS.ItemID])
	--local itemLink = self:GetItemLink(itemID, level, quality, enchantmentID)
	local itemLink = self:GetItemLink(self.ParseItemUID(salesItem[FIELDS.ItemID]))
	local icon, _, _, _, _ = GetItemLinkInfo(itemLink)
	--local itemLink = enchantmentID

	local row_guild = WZ.Chain(row:GetNamedChild("GuildName"))
		:SetFont(self.BaseFont)
		:SetText(salesItem[FIELDS.GuildName])
	.__END

	--row_guild.GetLabelControl():SetWrapMode(TEXT_WRAP_MODE_ELLIPSIS)

	local row_buyer = WZ.Chain(row:GetNamedChild("BuyerName"))
		:SetFont(self.BaseFont)
		:SetText(salesItem[FIELDS.Buyer])
	.__END

	local row_icon = WZ.Chain(row:GetNamedChild("Icon"))
		:SetTexture(icon)
		:SetHidden(false)
	.__END

	local row_ItemName = WZ.Chain(row:GetNamedChild("ItemName"))
		:SetFont(self.BaseFont)
		:SetText(itemLink)
		:SetAlpha(0.9)
	.__END

	local row_quantity = WZ.Chain(row:GetNamedChild("Quantity"))
		:SetFont(self.BaseFont)
		:SetText("x" .. tostring(salesItem[FIELDS.StackSize]))
		:SetAlpha(0.9)
		:SetHorizontalAlignment(RIGHT)
	.__END

	local row_time = WZ.Chain(row:GetNamedChild("Timestamp"))
		:SetFont(self.BaseFont)
		:SetText(self.TextTimeSince(salesItem[FIELDS.TimeStamp]))
	.__END

	-- local row_pricecontainer = WZ.Chain(row:GetNamedChild("PriceContainer"))
	-- .__END

	-- local row_price = WZ.Chain(row_pricecontainer:GetNamedChild("Price"))
	-- 	:SetFont(self.BaseFont)
	-- 	:SetText(salesItem[FIELDS.Price])
	-- 	:SetHorizontalAlignment(TEXT_ALIGN_RIGHT)
	-- .__END

	local row_coin = WZ.Chain(row:GetNamedChild("Coin"))
		:SetTexture(self.UI.Textures.GoldCoin)
		:SetHidden(false)
	.__END


	local row_price = WZ.Chain(row:GetNamedChild("Price"))
		:SetFont(self.BaseFont)
		:SetText(salesItem[FIELDS.Price])
		:SetHorizontalAlignment(TEXT_ALIGN_RIGHT)
	.__END

--row_price:SetHorizontalAlignment(TEXT_ALIGN_RIGHT)
--row_price:SetText("00000")

	--zo_binarysearch (searchData, dataList, comparator)
-- NonContiguousCount(tableObject)
--      --return count

	 --  itemCell:SetHandler("OnMouseDoubleClick", nil)
  -- itemCell:SetHandler("OnMouseEnter", nil)
-- buyerCellLabel:SetWrapMode(TEXT_WRAP_MODE_ELLIPSIS)
-- dataRow:GetNamedChild("ItemIcon"):SetTexture(icon)
	-- itemCell:SetText(zo_strformat("<<t:1>>", itemName))
--itemCell:SetHandler("OnMouseExit", function() ClearTooltip(ItemTooltip) end)	
end



ZO_CreateStringId("WM_TIME_SECONDS", "<<1[Now/%d s]>>")
ZO_CreateStringId("WM_TIME_MINUTES", "<<1[%d m]>>")
ZO_CreateStringId("WM_TIME_HOURS", "<<1[%d h]>>")
ZO_CreateStringId("WM_TIME_DAYS", "<<1[%d d]>>")
ZO_CreateStringId("WM_TIME_MONTHS", "<<1[%d m]>>")
ZO_CreateStringId("WM_TIME_YEARS", "<<1[%d y]>>")
ZO_CreateStringId("WM_TIME_SECONDS_LC", "<<1[now/%d s]>>")
ZO_CreateStringId("WM_TIME_MINUTES_LC", "<<1[%d m]>>")
ZO_CreateStringId("WM_TIME_HOURS_LC", "<<1[%d h]>>")
ZO_CreateStringId("WM_TIME_DAYS_LC", "<<1[%d d]>>")
ZO_CreateStringId("WM_TIME_MONTHS_LC", "<<1[%d m]>>")
ZO_CreateStringId("WM_TIME_YEARS_LC", "<<1[%d y]>>")

-- ZO_CreateStringId("WM_TIME_SECONDS", "<<1[Now/%d s]>>")
-- ZO_CreateStringId("WM_TIME_MINUTES", "<<1[%d minute ago/%d m]>>")
-- ZO_CreateStringId("WM_TIME_HOURS", "<<1[%d hour ago/%d h]>>")
-- ZO_CreateStringId("WM_TIME_DAYS", "<<1[Yesterday/%d d]>>")
-- ZO_CreateStringId("WM_TIME_MONTHS", "<<1[This month/%d m]>>")
-- ZO_CreateStringId("WM_TIME_YEARS", "<<1[This year/%d y]>>")
-- ZO_CreateStringId("WM_TIME_SECONDS_LC", "<<1[Now/%d s]>>")
-- ZO_CreateStringId("WM_TIME_MINUTES_LC", "<<1[%d minute ago/%d m]>>")
-- ZO_CreateStringId("WM_TIME_HOURS_LC", "<<1[%d hour ago/%d h]>>")
-- ZO_CreateStringId("WM_TIME_DAYS_LC", "<<1[yesterday/%d d]>>")
-- ZO_CreateStringId("WM_TIME_MONTHS_LC", "<<1[this month/%d m]>>")
-- ZO_CreateStringId("WM_TIME_YEARS_LC", "<<1[this year/%d y]>>")



--- Create a textual representation of a time interval 
-- Borrowed from Shopkeeper, adjusted for our purpose
-- (X and Y) or Z in LUA is the equivalent of C-style
-- ternary syntax X ? Y : Z so long as Y is not false or nil
function WM.TextTimeSince(theTime, useLowercase)
  local secsSince = GetTimeStamp() - theTime
  if secsSince < 75 then
    return ((useLowercase and zo_strformat(GetString(WM_TIME_SECONDS_LC), secsSince)) or 
             zo_strformat(GetString(WM_TIME_SECONDS), secsSince)) 
  elseif secsSince < 4500 then
    return ((useLowercase and zo_strformat(GetString(WM_TIME_SECONDS_LC), math.floor(secsSince / 60.0))) or
             zo_strformat(GetString(WM_TIME_MINUTES), math.floor(secsSince / 60.0)))
  elseif secsSince < 86400 then
    return ((useLowercase and zo_strformat(GetString(WM_TIME_SECONDS_LC), math.floor(secsSince / 3600.0))) or
             zo_strformat(GetString(WM_TIME_HOURS), math.floor(secsSince / 3600.0)))
  elseif secsSince < 2678400 then -- < 31 days (31*24*60*60)
    return ((useLowercase and zo_strformat(GetString(WM_TIME_DAYS_LC), math.floor(secsSince / 86400.0))) or 
             zo_strformat(GetString(WM_TIME_DAYS), math.floor(secsSince / 86400.0)))
  elseif secsSince < 31536000 then -- < 365 days (365*24*60*60)
  	local Integer, decimal = math.modf((secsSince / 2678400.0)+0.5)
    return ((useLowercase and zo_strformat(GetString(WM_TIME_MONTHS_LC), Integer)) or 
             zo_strformat(GetString(WM_TIME_MONTHS), Integer))
  else -- Years
    return ((useLowercase and zo_strformat(GetString(WM_TIME_YEARS_LC), math.floor(secsSince / 31536000.0))) or 
             zo_strformat(GetString(WM_TIME_YEARS), math.floor(secsSince / 31536000.0)))
  end
end
